/*
	$Id: ItemNotFoundException.java 5822 2011-10-24 11:44:02Z nicklas $

	Copyright (C) 2005 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

/**
	This exception is thrown when trying to load an item from
	the database that does not exist.

	@author Nicklas
	@version 2.0
*/
public class ItemNotFoundException
	extends InvalidDataException
{
	/**
		
	*/
	private static final long serialVersionUID = -4554252030783275058L;

	/**
		Creates a new <code>ItemNotFoundException</code>. The error
		message produced will look like:
		<code>Item not found: User[ID=1]</code>

		@param what A description of what was not found, for 
			example: User[ID=1]
	*/
	public ItemNotFoundException(String what)
	{
		super("Item not found: "+what);
	}

	/**
		Creates a new <code>ItemNotFoundException</code>. The error
		message produced will look like:
		<code>Item not found: User[ID=1]</code>
	
		@param what A description of what was not found, for 
			example: User[ID=1]
		@param cause The cause of the exception
		@since 3.0
	*/
	public ItemNotFoundException(String what, Throwable cause)
	{
		super("Item not found: "+what, cause);
	}

	
}



