/*
	$Id: SpotImage.java 7555 2018-12-17 10:16:47Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core;

import java.io.InputStream;
import java.io.ByteArrayInputStream;

/**
	Holds the image information about a single spot image
	in PNG format.

	@author Samuel, Nicklas
	@version 2.0
	@base.modified $Date: 2018-12-17 11:16:47 +0100 (må, 17 dec 2018) $
	@deprecated In 3.14, will be removed in the future without replacement
*/
@Deprecated
public class SpotImage
{
	private final byte[] image;

	/**
		Constructor that takes the image as a byte array.
		@param image Byte array of a PNG image
	*/
	SpotImage(byte[] image)
	{
		this.image = image;
	}


	/**
		Get an <code>InputStream</code> of the image.
		@return An <code>InputStream</code>
	*/
	public InputStream getInputStream()
	{
		return  new ByteArrayInputStream(image);
	}

	/**
		Get the image as an array of bytes. The returned array is a copy of the 
		original image.
		@return An array of bytes representing the image in PNG format
	*/
	public byte[] getImage()
	{
		byte[] copy = new byte[image.length];
		System.arraycopy(image, 0, copy, 0, image.length);
		return copy;
	}
	
	/**
		Get the number of bytes of the image.
	*/
	public int getBytes()
	{
		return image.length;
	}
}
