/*
	$Id $

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.query;

import net.sf.basedb.core.AnnotationType;

/**
	An expression representing the value of an annotation.
	<p>
	Throws an <code>UnsupportedOperationException</code> if 
	{@link Query#getQueryType()} isn't {@link QueryType#HQL}.

	@author Nicklas
	@since 3.2
	@see Annotations#expression(String, AnnotationType)
	@base.modified $Date$
*/
public class AnnotationExpression
	extends HqlPropertyExpression
{
	private final String alias;
	private final AnnotationType annotationType;

	AnnotationExpression(String alias, AnnotationType annotationType)
	{
		super("atj" + annotationType.getId(), null, null);
		this.alias = alias;
		this.annotationType = annotationType;
	}
	// -------------------------------------------
	
	public String getAlias()
	{
		return alias;
	}
	
	public AnnotationType getAnnotationType()
	{
		return annotationType;
	}
	
	public String getJoinAlias()
	{
		return "atj" + annotationType.getId();
	}
}

