/**
	$Id: AffymetrixData.java 4514 2008-09-11 20:07:12Z jari $

	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.test;

import java.util.HashMap;
import java.util.Map;

/**
	Helper class for getting parameters to import plugins for the mouse data
	set in /testdata/mouse.

	@author nicklas
	@version 2.2
	@base.modified $Date: 2008-09-11 22:07:12 +0200 (to, 11 sep 2008) $
*/
public class AffymetrixData
{

	/**
		Get configuration parameters required for the reporter importer.
	*/
	public static Map<String, Object> getReporterParameters()
	{
		Map<String, Object> parameters = new HashMap<String, Object>();
		parameters.put("dataSplitterRegexp", "(?!\"),(?=\")");
		parameters.put("dataHeaderRegexp", "\"Probe Set ID\",\"GeneChip Array\".*");
		parameters.put("minDataColumns", 5);
	
		parameters.put("reporterIdColumnMapping", "\\Probe Set ID\\");
		parameters.put("nameColumnMapping", "\\Probe Set ID\\");
		parameters.put("symbolColumnMapping", "\\Gene Symbol\\");
		parameters.put("descriptionColumnMapping", "\\Target Description\\");
	
		parameters.put("extendedColumnMapping.clusterId", "\\Archival UniGene Cluster\\");
		parameters.put("extendedColumnMapping.omim", "\\OMIM\\");
		return parameters;
	}

}
