<%-- $Id: view_role.jsp 7216 2016-10-19 20:17:37Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.RoleKey"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ROLE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
	
	private static final String getShortPermissions(Item itemType, Set<Permission> permissions)
	{
		Set<Permission> defined = itemType.getDefinedPermissions();
		StringBuilder sb = new StringBuilder();
		if (defined.contains(Permission.CREATE)) sb.append(permissions.contains(Permission.CREATE) ? "C" : "-");
		if (defined.contains(Permission.READ)) sb.append(permissions.contains(Permission.READ) ? "R" : "-");
		if (defined.contains(Permission.USE)) sb.append(permissions.contains(Permission.USE) ? "U" : "-");
		if (defined.contains(Permission.RESTRICTED_WRITE)) sb.append(permissions.contains(Permission.RESTRICTED_WRITE) ? "A" : "-");
		if (defined.contains(Permission.WRITE)) sb.append(permissions.contains(Permission.WRITE) ? "W" : "-");
		if (defined.contains(Permission.DELETE)) sb.append(permissions.contains(Permission.DELETE) ? "D" : "-");
		if (defined.contains(Permission.SET_OWNER)) sb.append(permissions.contains(Permission.SET_OWNER) ? "O" : "-");
		if (defined.contains(Permission.SET_PERMISSION)) sb.append(permissions.contains(Permission.SET_PERMISSION) ? "P" : "-");
		return sb.toString();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	Role role = Role.getById(dc, itemId);
	
	RoleKey system = RoleKey.getById(dc, SystemItems.getRoleKeyId(Item.SYSTEM));
	final boolean hasShareToEveryone = system.getPermissions(role).contains(Permission.SHARE_TO_EVERYONE);
	final boolean hasActAsAnotherUser = system.getPermissions(role).contains(Permission.ACT_AS_ANOTHER_USER);
	final boolean hasSelectJobagent = system.getPermissions(role).contains(Permission.SELECT_JOBAGENT);
	
	final boolean writePermission = role.hasPermission(Permission.WRITE);
	final boolean deletePermission = role.hasPermission(Permission.DELETE);
	final boolean isRemoved = role.isRemoved();
	final boolean isUsed = isRemoved && role.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, role);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~roles.js" styles="toolbar.css,table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<p:path><p:pathelement
			title="Roles" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(role.getName())%>"
			/></p:path>
			
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main"
			subclass="content mastertabcontrol" 
			active="properties">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon 
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this role" : "You do not have permission to edit this role"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!role.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this role" : "You do not have permission to delete this role"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=role.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this role" : "You do not have permission to restore this role"%>" 
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="role.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(role.getName())%></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(role.getEntryDate())%></td>
			</tr>
			<tr>
				<th>System ID</th>
				<td><%=HTML.encodeTags(role.getSystemId())%></td>
			</tr>
			<tr>
				<th>Is default</th>
				<td><%=role.isDefault() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(role)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(role.getDescription())%></td>
			</tr>
			</table>
			</div>
			
			<base:section 
				id="permissions" 
				title="<%="Permissions"%>"
				context="<%=cc%>"
				>
				<%
				Map<String, List<Item>> permissionGroups = PermissionUtil.getPermissionGroups();
				%>
				<table class="fullform fullborder">
				<tbody class="sectionheader">
					<tr>
						<th colspan="<%=permissionGroups.size() * 2 %>">System-level permissions</th>
					</tr>
				</tbody>
				<tr>
					<th>Share to everyone</th>
					<td><%=hasShareToEveryone ? "yes" : "no"%></td>
					<th class="leftborder">Select job agent</th>
					<td><%=hasSelectJobagent ? "yes" : "no"%></td>
					<th class="leftborder">Act as another user</th>
					<td><%=hasActAsAnotherUser ? "yes" : "no"%></td>
					<td colspan="<%=permissionGroups.size() * 2 - 6 %>"></td>
				</tr>
				<tbody class="sectionheader">
					<tr>
					<%
					for (String name : permissionGroups.keySet())
					{
						%>
						<th colspan="2"><%=name%></th>
						<%
					}
					%>
					</tr>
				</tbody>
				<%
				int newItems = 0;
				int rowIndex = 0;
				do
				{
					newItems = 0;
					int colIndex = 0;
					StringBuilder sb = new StringBuilder();
					sb.append("<tr>");
					for (String name : permissionGroups.keySet())
					{
						List<Item> items = permissionGroups.get(name);
						if (items.size() > rowIndex)
						{
							newItems++;
							Item item = items.get(rowIndex);
							int keyId = SystemItems.getRoleKeyId(item);
							RoleKey key = RoleKey.getById(dc, keyId);
							
							sb.append("<th");
							if (colIndex > 0) sb.append(" class=\"leftborder\"");
							sb.append(">").append(key.getName()).append("</th>");
							sb.append("<td>");
														
							if (keyId != 0)
							{
								Set<Permission> permissions = key.getPermissions(role);
								sb.append(getShortPermissions(item, permissions));
							}
							else
							{
								sb.append("(undefined key)");
							}
							sb.append("</td>");
						}
						else
						{
							sb.append("<th class=\"subprompt");
							if (colIndex > 0) sb.append(" leftborder");
							sb.append("\"></th><td></td>");
						}
						colIndex++;
					}
					if (newItems > 0)
					{
						%>
						<%=sb.toString()%>
						<%
					}
					rowIndex++;
				} while (newItems > 0);
				%>
				</table>
				<b>C</b> = Create, <b>R</b> = Read, <b>U</b> = Use, <b>A</b> = Annotate,
				<b>W</b> = Write, <b>D</b> = Delete, <b>O</b> = Change owner, <b>P</b> = Change permissions
			</base:section>
			<%
			ItemQuery<User> userQuery = role.getUsers();
			userQuery.include(Include.ALL);
			userQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<User> users = userQuery.list(dc);
			%>
			<base:section 
				id="members" 
				title="<%="Members (" + users.size() + ")"%>"
				context="<%=cc%>"
				>
				<%
				if (users.size() == 0)
				{
					%>
					<div class="messagecontainer note">
					There are no members of this role (or, you don't have permission to view them).
					</div>
					<%
				}
				else
				{
					%>
					<tbl:table
						id="members"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="type"
						title="Type"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:headers>
							<tbl:headerrow>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						for (User user : users)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
										image="deleted.png" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="type">User</tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(user.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
					<%
				}
				%>
			</base:section>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this role" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
