<%-- $Id: list_extracts.jsp 7581 2019-01-16 08:39:44Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.Values"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.EXTRACT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("extract", "extracts");
final DbControl dc = sc.newDbControl();
ItemResultIterator<Extract> extracts = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();
List<AnnotationLoaderUtil> bioPlateAnnotationLoaders = new ArrayList<AnnotationLoaderUtil>();
try
{
	ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}
	annotationTypeQuery = Base.getInheritedAnnotationColumns(cc.getSetting("columns"));
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at, false, true));
	}
	ItemQuery<AnnotationType> plateAnnotationTypeQuery = Base.getAnnotationTypesQuery(Item.BIOPLATE);
	for (AnnotationType at : plateAnnotationTypeQuery.list(dc))
	{
		bioPlateAnnotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	final boolean createBioAssayPermission = sc.hasPermission(Permission.CREATE, Item.PHYSICALBIOASSAY);
	final boolean createDerivedBioAssayPermission = sc.hasPermission(Permission.CREATE, Item.DERIVEDBIOASSAY);
	final boolean createRawBioAssayPermission = sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY);

	// Child physical bioassays
	final ItemQuery<PhysicalBioAssay> bioAssayQuery = PhysicalBioAssay.getQuery();
	bioAssayQuery.join(Hql.innerJoin("creationEvent", "ce"));
	bioAssayQuery.join(Hql.innerJoin("ce", "sources", "src"));
	bioAssayQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Hql.entityParameter("extract", Item.EXTRACT)));
	bioAssayQuery.order(Orders.asc(Hql.property("name")));
	bioAssayQuery.include(cc.getInclude());

	// Child derived bioassays
	final ItemQuery<DerivedBioAssay> derivedAssayQuery = DerivedBioAssay.getQuery();
	derivedAssayQuery.restrict(Restrictions.eq(Hql.property("extract"), Hql.entityParameter("extract", Item.EXTRACT)));
	derivedAssayQuery.order(Orders.asc(Hql.property("name")));
	derivedAssayQuery.include(cc.getInclude());

	// Child raw bioassays
	final ItemQuery<RawBioAssay> rawAssayQuery = RawBioAssay.getQuery();
	rawAssayQuery.restrict(Restrictions.eq(Hql.property("parentExtract"), Hql.entityParameter("extract", Item.EXTRACT)));
	rawAssayQuery.order(Orders.asc(Hql.property("name")));
	rawAssayQuery.include(cc.getInclude());

	// Child extracts
	final ItemQuery<Extract> childExtractsQuery = Extract.getQuery();
	childExtractsQuery.join(Hql.innerJoin("creationEvent", "ce"));
	childExtractsQuery.join(Hql.innerJoin("ce", "sources", "src"));
	childExtractsQuery.restrict(Restrictions.eq(Hql.property("src", "bioMaterial"), Hql.entityParameter("extract", Item.EXTRACT)));
	childExtractsQuery.order(Orders.asc(Hql.property("name")));
	childExtractsQuery.include(cc.getInclude());
	
	// Parent extracts
	final ItemQuery<Extract> parentExtractsQuery = Extract.getQuery();
	parentExtractsQuery.join(Hql.innerJoin("childCreationEvents", "cce"));
	parentExtractsQuery.join(Hql.innerJoin("cce", "event", "evt"));
	parentExtractsQuery.restrict(Restrictions.eq(Hql.alias("evt"), Hql.entityParameter("creationEvent", Item.BIOMATERIALEVENT)));
	parentExtractsQuery.order(Orders.asc(Hql.property("name")));
	parentExtractsQuery.include(cc.getInclude());
	
	Unit microGram = UnitUtil.getUnit(dc, Quantity.MASS, "µg");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<Extract> query = Base.getConfiguredQuery(dc, cc, true, Extract.getQuery(), mode);
		extracts = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	int numListed = 0;
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Number> numericFormatter = FormatterFactory.getNumberFormatter(sc);
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	Enumeration<String, String> wellRows = new Enumeration<String, String>();
	ItemQuery<PlateGeometry> geometryQuery = PlateGeometry.getQuery();	
	geometryQuery.order(Orders.desc(Hql.property("rows")));
	ItemResultIterator<PlateGeometry> result = geometryQuery.iterate(dc);
	int maxRows = result.next().getRows();
	for (int r = 0; r < maxRows && r < 256; r++)
	{
		wellRows.add(Integer.toString(r), rowFormatter.format(r));
	}

	Enumeration<String, String> wellColumns = new Enumeration<String, String>();
	ItemQuery<PlateGeometry> columnsGeometryQuery = PlateGeometry.getQuery();	
	columnsGeometryQuery.order(Orders.desc(Hql.property("columns")));
	ItemResultIterator<PlateGeometry> columnsResult = columnsGeometryQuery.iterate(dc);
	int maxColumns = columnsResult.next().getColumns();
	for (int c = 0; c < maxColumns && c < 256; c++)
	{
		wellColumns.add(Integer.toString(c), columnFormatter.format(c));
	}

	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title==null ? "Extracts" : title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,~extracts.js" styles="table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
	<h1><%=title==null ? "Extracts" : title%></h1>
	<div class="content">
		<tbl:table 
			id="extracts" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			data-inherited-annotations="true"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="itemSubtype"
				property="itemSubtype"
				sortproperty="itemSubtype.name"
				exportproperty="itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(subtypesQuery.list(dc), "-none-")%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="externalId"
				property="externalId"
				datatype="string"
				title="External id"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="originalQuantity"
				property="originalQuantity"
				datatype="float"
				title="Original quantity (µg)"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=microGram%>"
				formatter="<%=numericFormatter%>"
			/>
			<tbl:columndef 
				id="remainingQuantity"
				property="remainingQuantity"
				datatype="float"
				title="Remaining quantity (µg)"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=microGram%>"
				formatter="<%=numericFormatter%>"
			/>
			<tbl:columndef 
				id="tag"
				property="tag.name"
				datatype="string"
				title="Tag"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="protocol"
				property="creationEvent.protocol"
				sortproperty="creationEvent.protocol.name"
				filterproperty="creationEvent.protocol.name"
				exportproperty="creationEvent.protocol.name"
				datatype="string"
				title="Protocol"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="kit"
				property="creationEvent.kit"
				sortproperty="creationEvent.kit.name"
				filterproperty="creationEvent.kit.name"
				exportproperty="creationEvent.kit.name"
				datatype="string"
				title="Kit"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="eventDate"
				property="creationEvent.eventDate"
				datatype="date"
				title="Created"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="entryDate"
				property="creationEvent.entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<%
			Enumeration<String, String> parentTypes = new Enumeration<String, String>();
			parentTypes.add("", "-none-");
			parentTypes.add(Integer.toString(Item.SAMPLE.getValue()), Item.SAMPLE.toString());
			parentTypes.add(Integer.toString(Item.EXTRACT.getValue()), Item.EXTRACT.toString());
			%>
			<tbl:columndef
				id="parentType"
				title="Parent type"
				property="parentType"
				enumeration="<%=parentTypes%>"
				datatype="int"
				filterable="true"
				exportable="true"
				sortable="true"
			/>
			<tbl:columndef
				id="parents"
				title="Parent items"
				property="&creationEvent.sources(bioMaterial.name)"
				sortproperty="parent.name"
				datatype="string"
				filterable="true"
				exportable="true"
				sortable="true"
			/>
			<tbl:columndef
				id="children"
				title="Child extracts"
				property="&childCreationEvents(event.bioMaterial.name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="physicalBioAssays"
				title="Physical bioassays"
				property="&childCreationEvents(event.physicalBioAssay.name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="derivedBioAssays"
				title="Derived bioassays"
				property="&derivedBioAssays(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="rawBioAssays"
				title="Raw bioassays"
				property="&rawBioAssays(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioPlate"
				property="bioWell.bioPlate.name"
				sortproperty="bioWell.bioPlate.name"
				filterproperty="bioWell.bioPlate.name"
				exportproperty="bioWell.bioPlate.name"
				datatype="string"
				title="Bioplate"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="bioWellRow"
				property="bioWell.row"
				sortproperty="bioWell.row"
				datatype="int"
				title="Biowell row"	 
				filterable="true"
				enumeration="<%=wellRows%>"
				exportable="true"
				sortable="true"
				formatter="<%=rowFormatter%>"
			/>
			<tbl:columndef 
				id="bioWellColumn"
				property="bioWell.column"
				sortproperty="bioWell.column"
				datatype="int"
				title="Biowell column"	 
				filterable="true"
				enumeration="<%=wellColumns%>"
				exportable="true"
				sortable="true"
				formatter="<%=columnFormatter%>"
			/>		
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>			
			<tbl:columndef
				id="itemList"
				property="§itemLists"
				datatype="int"
				title="Item list"
				filterable="true"
				enumeration="<%=Base.getItemListsEnum(dc, itemType, cc.getInclude())%>"
				multiple="false"
			/>
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					if (!at.getDisplayAsList()) annotationEnum.add("", "-none-");
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+(loader.isSearchingInheritedAnnotations() ? " [I]" : " [A]")%>" 
					property="<%=(loader.isSearchingInheritedAnnotations() ? "##" : "#")+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1 && !loader.isSearchingInheritedAnnotations()%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			for (AnnotationLoaderUtil loader : bioPlateAnnotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					if (!at.getDisplayAsList()) annotationEnum.add("", "-none-");
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="pa"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+ " [P]"%>" 
					property="<%="#(bioWell.bioPlate)"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
		<div class="panelgroup bg-filled-50 bottomborder">
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				subclass="bottomborder"
				>
				<tbl:button 
					id="btnNewItem"
					disabled="<%=!createPermission%>" 
					image="new.png" 
					title="New&hellip;" 
					tooltip="<%=createPermission ? "Create new extract" : "You do not have permission to create extracts"%>" 
				/>
				<tbl:button 
					id="btnNewPooledItem"
					disabled="<%=!createPermission%>" 
					image="new_pooled.png" 
					title="Pool&hellip;" 
					tooltip="<%=createPermission ? "Create new pooled extract" : "You do not have permission to create extracts"%>" 
				/>
				<tbl:button 
					id="btnNewPhysicalBioAssay"
					disabled="<%=createBioAssayPermission ? false : true%>" 
					image="add.png" 
					title="New physical bioassay&hellip;" 
					tooltip="<%=createBioAssayPermission ? "Create new bioassay with the selected extracts" : "You do not have permission to create bioassays"%>" 
				/>
				<tbl:button 
					id="btnDeleteItems"
					image="delete.png"
					title="Delete" 
					tooltip="Delete the selected items" 
				/>
				<tbl:button 
					id="btnRestoreItems"
					image="restore.png"
					title="Restore" 
					tooltip="Restore the selected (deleted) items"
				/>
				<tbl:button 
					id="btnShareItems"
					image="share.png"
					title="Share&hellip;" 
					tooltip="Share the selected items"
				/>
				<tbl:button 
					id="btnSetOwner"
					image="take_ownership.png"
					title="Set owner&hellip;"
					tooltip="Change owner of the selected items"
				/>
				<tbl:button 
					id="btnColumns"
					image="columns.png" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button
					id="btnNewItemList"
					image="add.png"
					title="New item list&hellip;"
					tooltip="Create a new item list from matching extracts"
					visible="<%=sc.hasPermission(Permission.CREATE, Item.ITEMLIST)%>"
				/>
				<tbl:button 
					id="btnPlaceOnPlate"
					image="place_on_plate.png" 
					title="Place on plate&hellip;" 
					tooltip="Place the selected/matching extracts on a bioplate" 
				/>
				<tbl:button
					id="btnInheritAnnotations"
					image="inherit.png"
					title="Inherit annotations&hellip;"
					tooltip="Batch inherit annotations from parent items"
				/>
				<tbl:button 
					id="btnImport"
					data-plugin-type="IMPORT"
					image="import.png" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					id="btnExport"
					data-plugin-type="EXPORT"
					image="export.png" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					id="btnRunPlugin"
					data-plugin-type="OTHER"
					image="runplugin.png" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:panel>
					<tbl:presetselector />
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=extracts == null ? 0 : extracts.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
				/>
			</tbl:panel>
		</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header colspan="3" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="index" />
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasCheck()%>"
								><base:icon 
									subclass="link table-check"
									image="check_uncheck.png" 
									tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
									visible="<%=lastRow%>"
								/></tbl:header>
							<tbl:header 
								subclass="check" 
								visible="<%=mode.hasRadio()%>"
								/>
							<tbl:header 
								subclass="icons" 
								visible="<%=mode.hasIcons()%>"
								>
								<base:icon
									subclass="link table-filter-row-action"
									image="add.png"
									tooltip="Add extra filter row"
									visible="<%=lastRow%>"
								/><base:icon
									subclass="link table-filter-row-action"
									image="remove.png"
									tooltip="Remove this filter row"
									visible="<%=numRows > 1 || numFilters > 0 %>"
									data-remove-row="<%=filterNo%>"
								/>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (extracts != null)
					{						
						while (extracts.hasNext())
						{
							Extract item = extracts.next();
							Item parentType = item.getParentType();
							BioMaterialEvent creationEvent = item.getCreationEvent();
							int itemId = item.getId();
							boolean usePermission = item.hasPermission(Permission.USE);
							
							
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="deleted.png"
										id="<%="delete."+itemId %>"
										subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
										data-item-id="<%=itemId%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="shared.png" 
										id="<%="share."+itemId %>"
										subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
										data-item-id="<%=itemId%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="itemSubtype"><base:propertyvalue 
										item="<%=item%>" 
										property="itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="externalId"><%=HTML.encodeTags(item.getExternalId())%></tbl:cell>
								<tbl:cell column="originalQuantity" value="<%=item.getOriginalQuantity()%>" />
								<tbl:cell column="remainingQuantity" value="<%=item.getRemainingQuantity()%>" />
								<tbl:cell column="tag"
									><base:propertyvalue 
										item="<%=item%>" 
										property="tag"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="protocol"
									><base:propertyvalue 
										item="<%=creationEvent%>" 
										property="protocol"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="kit"
									><base:propertyvalue 
										item="<%=creationEvent%>" 
										property="kit"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="eventDate" value="<%=creationEvent.getEventDate()%>" />
								<tbl:cell column="entryDate" value="<%=creationEvent.getEntryDate()%>" />
								<tbl:cell column="parentType"><%=parentType == null ? "" : parentType.toString() %></tbl:cell>
								<tbl:cell column="parents">
									<%
									if (item.hasSingleParent() || parentType == null)
									{
										Float usedQuantity = null;
										if (parentType != null)
										{
											try
											{
												usedQuantity = creationEvent.getUsedQuantity((MeasuredBioMaterial)item.getParent());
											}
											catch (PermissionDeniedException ex)
											{}
										}
										%>
										<base:propertyvalue item="<%=item%>" property="parent" />
										<%=usedQuantity != null ? "(" + numericFormatter.format(usedQuantity) + "µg)" : ""%>
										<%
									}
									else
									{
										String separator = "";
										parentExtractsQuery.setEntityParameter("creationEvent", creationEvent);
										for (Extract e : parentExtractsQuery.list(dc))
										{
											Float usedQuantity = creationEvent.getUsedQuantity(e);
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, e, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(e.getName()));
											}
											if (usedQuantity != null)
											{
												out.write(" (" + numericFormatter.format(usedQuantity) + "µg)");
											}
											separator = ", ";
										}
									}
									%>
									<%=parentType != null ? "<span class=\"itemsubtype\">(" + parentType + ")</span>" : "" %>
								</tbl:cell>
								<tbl:cell column="children">
									<%
									childExtractsQuery.setEntityParameter("extract", item);
									String separator = "";
									for (Extract e : childExtractsQuery.list(dc))
									{
										out.write(separator);
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, e, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(e.getName()));
										}
										separator = ", ";
									}
									%>
									<base:icon
										id="<%="newextract."+itemId%>"
										image="add.png" 
										subclass="auto-init"
										data-auto-init="new-extract"
										data-item-id="<%=itemId %>"
										tooltip="Create new child extract" 
										visible="<%=mode.hasEditLink() && createPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="physicalBioAssays">
									<%									
									try
									{
										bioAssayQuery.setEntityParameter("extract", item);
										String separator = "";
										for (PhysicalBioAssay pba : bioAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, pba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(pba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="derivedBioAssays">
									<%									
									try
									{
										derivedAssayQuery.setEntityParameter("extract", item);
										String separator = "";
										for (DerivedBioAssay dba : derivedAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, dba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(dba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
									<base:icon
										id="<%="newDerivedBioAssay."+itemId%>"
										image="add.png" 
										subclass="auto-init"
										data-auto-init="new-derived-bioassay"
										data-item-id="<%=itemId %>"
										tooltip="Create new derived bioassay from this extract" 
										visible="<%=mode.hasEditLink() && createDerivedBioAssayPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="rawBioAssays">
									<%									
									try
									{
										rawAssayQuery.setEntityParameter("extract", item);
										String separator = "";
										for (RawBioAssay rba : rawAssayQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, rba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(rba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
									<base:icon
										id="<%="newRawBioAssay."+itemId%>"
										image="add.png" 
										subclass="auto-init"
										data-auto-init="new-raw-bioassay"
										data-item-id="<%=itemId %>"
										tooltip="Create new raw bioassay from this extract" 
										visible="<%=mode.hasEditLink() && createRawBioAssayPermission && usePermission %>"
									/>
								</tbl:cell>
								<%								
								BioWell well = null;
								BioPlate bioPlate = null;
								boolean readBioWell = true;
								try
								{
									well = item.getBioWell();
									if (well != null) bioPlate = well.getPlate();
								}
								catch(PermissionDeniedException e)
								{
									readBioWell = false;
								}
								if (!readBioWell)
								{
									%>
									<tbl:cell column="bioWellRow"><i>- denied -</i> </tbl:cell>
									<tbl:cell column="bioWellColumn"><i>- denied -</i> </tbl:cell>
									<tbl:cell column="bioPlate"><i>- denied -</i> </tbl:cell>
									<%
								}
								else if (well == null)
								{
									%>
									<tbl:cell column="bioWellRow"><i>- none -</i> </tbl:cell>
									<tbl:cell column="bioWellColumn"><i>- none -</i> </tbl:cell>
									<tbl:cell column="bioPlate"><i>- none -</i> </tbl:cell>
									<%
									
								}
								else
								{								
									%>
									<tbl:cell column="bioWellRow">
										<tbl:cellvalue value="<%=well.getRow()%>"/>
									</tbl:cell>
									<tbl:cell column="bioWellColumn">
										<tbl:cellvalue value="<%=well.getColumn()%>"/>
									</tbl:cell>
									<tbl:cell column="bioPlate"><%=Base.getLinkedName(ID, bioPlate, false, true)%></tbl:cell>
									<%
								}
								%>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>								
								<%
								if (item.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, item.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.overridesDefaultAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								if (bioPlate != null && bioPlate.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, bioPlate.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : bioPlateAnnotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%="pa"+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.overridesDefaultAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
						if (numListed == 0)
						{
							%>
							<tbl:panel subclass="bg-filled-50">
								<div class="messagecontainer note">
								<%=extracts == null || extracts.getTotalCount() == 0 ? "No extracts were found" : "No extracts on this page. Please select another page!" %>
								</div>
							</tbl:panel>
							<%
						}
					%>					
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (extracts != null) extracts.close();
	if (dc != null) dc.close();
}
%>
