/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2013 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var EditMultiple = function()
{
	var editMultiple = {};
	
	editMultiple.initPage = function()
	{
		// Save + Close buttons
		Buttons.addClickHandler('btnSave', editMultiple.save);
		Buttons.addClickHandler('close', App.closeWindow);
		
		// Tab validation
		TabControl.addTabValidator('settings.info', editMultiple.validateFile);
		
		// MIME type
		Events.addEventHandler('keepMimeType', 'click', editMultiple.keepMimeTypeOnClick);
		Buttons.addClickHandler('selectMimeType', editMultiple.selectMimeType);
		Events.addEventHandler('selectMimeType', 'base-selected', editMultiple.setMimeTypeCallback);
	}
	
	
	// Validate the news information
	editMultiple.validateFile = function()
	{
		return true;
	}
	
	// Save the news settings
	editMultiple.save = function()
	{
		var frm = document.forms['file'];
		if (TabControl.validateActiveTab('settings'))
		{
			frm.submit();
		}
	}

	editMultiple.keepMimeTypeOnClick = function()
	{
		var frm = document.forms['file'];
		frm.mimeType.disabled = frm.keepMimeType.checked;
		if (!frm.mimeType.disabled) frm.mimeType.focus();
	}

	editMultiple.selectMimeType = function()
	{
		Dialogs.selectItem('MIMETYPE', 'selectMimeType', 0);
	}
	editMultiple.setMimeTypeCallback = function(event)
	{
		var frm = document.forms['file'];
		frm.mimeType.value = event.detail.name;
		frm.mimeType.disabled = false;
		frm.keepMimeType.checked = false;
	}

	return editMultiple;
}();

Doc.onLoad(EditMultiple.initPage);
