<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Kit"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.NameableConverter"
	import="org.json.simple.JSONObject"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.DERIVEDBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	DerivedBioAssay bioAssay = null;
	String title = null;
	
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;

	boolean readCurrentExtract = true;
	Extract currentExtract = null;

	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;

	boolean readCurrentKit = true;
	Kit currentKit = null;
	
	boolean readCurrentHardware = true;
	Hardware currentHardware = null;
	
	boolean readCurrentSoftware = true;
	Software currentSoftware = null;

	ItemQuery<PhysicalBioAssay> physicalQuery = null;
	ItemQuery<DerivedBioAssay> parentQuery = null;
	
	Item parentType = null;
	
	if (itemId == 0)
	{
		title = "New derived bioassay";
		cc.removeObject("item");
		int parentId = Values.getInt(request.getParameter("parent_id"));
		int physicalBioAssayId = Values.getInt(request.getParameter("physicalbioassay_id"));
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		
		if (parentId != 0)
		{
			parentType = Item.DERIVEDBIOASSAY;
			DerivedBioAssay dba = DerivedBioAssay.getById(dc, parentId);
			parentQuery = DerivedBioAssay.getQuery();
			parentQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(parentId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, dba, Item.DERIVEDBIOASSAY);
			}
		}
		else if (physicalBioAssayId != 0)
		{
			parentType = Item.PHYSICALBIOASSAY;
			PhysicalBioAssay pba = PhysicalBioAssay.getById(dc, physicalBioAssayId);
			physicalQuery = PhysicalBioAssay.getQuery();
			physicalQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(physicalBioAssayId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, pba, Item.DERIVEDBIOASSAY);
			}
		}
		else if ("PHYISCALBIOASSAY".equals(request.getParameter("useParents")))
		{
			parentType = Item.PHYSICALBIOASSAY;
			physicalQuery = PhysicalBioAssay.getQuery();
			physicalQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			physicalQuery.setParameter("selected", sc.getCurrentContext(Item.PHYSICALBIOASSAY).getSelected(), Type.INT);
		}
		else if ("DERIVEDBIOASSAY".equals(request.getParameter("useParents")))
		{
			parentType = Item.DERIVEDBIOASSAY;
			parentQuery = DerivedBioAssay.getQuery();
			parentQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			parentQuery.setParameter("selected", cc.getSelected(), Type.INT);
		}

		int extractId = Values.getInt(request.getParameter("extract_id"));
		if (extractId != 0)
		{
			currentExtract = Extract.getById(dc, extractId);
		}
		else if (cc.getPropertyFilter("extract.name") != null)
		{
			currentExtract = Base.getFirstMatching(dc, Extract.getQuery(), "name", cc.getPropertyFilter("extract.name"));
		}

		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
	}
	else
	{
		bioAssay = DerivedBioAssay.getById(dc, itemId);
		bioAssay.checkPermission(Permission.WRITE);
		cc.setObject("item", bioAssay);
		title = "Edit bioassay -- " + HTML.encodeTags(bioAssay.getName());
		
		if (bioAssay.isRoot())
		{
			physicalQuery = bioAssay.getPhysicalBioAssays();
			parentType = Item.PHYSICALBIOASSAY;
		}
		else
		{
			parentQuery = bioAssay.getParents();
			parentType = Item.DERIVEDBIOASSAY;
		}
		
		try
		{
			currentSubtype = bioAssay.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}
		try
		{
			currentExtract = bioAssay.getExtract();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentExtract = false;
		}
		try
		{
			currentProtocol = bioAssay.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentKit = bioAssay.getKit();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentKit = false;
		}
		try
		{
			currentHardware = bioAssay.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
		try
		{
			currentSoftware = bioAssay.getSoftware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSoftware = false;
		}
	}

	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	List<Hardware> defaultHardware = null;
	List<Software> defaultSoftware = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.PROTOCOL);
		defaultHardware = (List<Hardware>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.HARDWARE);
		defaultSoftware = (List<Software>)activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.SOFTWARE);
	}

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Kit> recentKits = (List<Kit>)cc.getRecent(dc, Item.KIT, currentSubtype);
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, currentSubtype);
	List<Software> recentSoftware = (List<Software>)cc.getRecent(dc, Item.SOFTWARE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	// Load parent physical bioassays
	JSONObject jsonPhysicalBioAssays = new JSONObject();
	jsonPhysicalBioAssays.put("itemType", "PHYSICALBIOASSAY");
	if (physicalQuery != null)
	{
		physicalQuery.include(Include.ALL);
		physicalQuery.order(Orders.asc(Hql.property("name")));
		jsonPhysicalBioAssays.put("items", JsonUtil.toArray(physicalQuery.iterate(dc), new NameableConverter()));
	}

	// Load parent derived bioassays
	JSONObject jsonParents = new JSONObject();
	jsonParents.put("itemType", "DERIVEDBIOASSAY");
	if (parentQuery != null)
	{
		parentQuery.include(Include.ALL);
		parentQuery.order(Orders.asc(Hql.property("name")));
		ItemResultList<DerivedBioAssay> parents = parentQuery.list(dc);
		jsonParents.put("items", JsonUtil.toArray(parents, new NameableConverter()));
		if (parents.size() == 1 && currentExtract == null)
		{
			try
			{
				currentExtract = parents.get(0).getExtract();
			}
			catch (PermissionDeniedException ex)
			{}
		}
	}
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioAssay);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,subtypes.js,linkitems-2.js,~bioassays.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioAssay">
		<input type="hidden" name="cmd" value="UpdateItem">
		
		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && bioAssay != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Bioassay" helpid="derivedbioassay.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=bioAssay == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(bioAssay == null ? Values.getString(cc.getPropertyValue("name"), "New derived bioassay") : bioAssay.getName())%>" 
					maxlength="<%=DerivedBioAssay.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id" id="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && bioAssay != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<%
			if (bioAssay == null)
			{
				%>
				<tr>
					<th>Parent type</th>
					<td>
						<input id="isRoot" type="radio" name="isRoot" value="1" 
							<%=parentType == Item.PHYSICALBIOASSAY ? "checked" : "" %>
							><label for="isRoot">Physical bioassay</label>
						<input id="isChild" type="radio" name="isRoot" value="0"
							<%=parentType != Item.PHYSICALBIOASSAY ? "checked" : "" %>
							><label for="isChild">Derived bioassay</label><br>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<%
			if (bioAssay == null || bioAssay.isRoot())
			{
				%>
				<tr id="physicalBioAssaySection">
					<th class="subprompt">- physical bioassays</th>
					<td>
						<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="physicalBioAssays" id="physicalBioAssays"
								class="auto-init"
								data-auto-init="link-container"
								data-initial-items="[<%=HTML.encodeTags(jsonPhysicalBioAssays.toJSONString()) %>]"
								data-initial-action="<%=bioAssay == null ? 1 : 0 %>"
								size="4" multiple>
							</select>
						</td>
						<td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnAddPhysicalBioAssays"
									subclass="leftaligned"
									style="width: 12em;"
									title="Add&nbsp;bioassays&hellip;" 
									tooltip="Add physical bioassays"
								/>
								<base:button 
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="physicalBioAssays"
									style="width: 12em;"
									title="Remove" 
									tooltip="Remove the selected physical bioassays"
								/>
							</base:buttongroup>
						</td>
						</tr>
						</table>
						</div>
					</td>
					<td></td>
				</tr>
				<%
			}
			if (bioAssay == null || !bioAssay.isRoot())
			{
				%>
				<tr id="parentBioAssaySection">
					<th class="subprompt">- bioassays</th>
					<td>
						<div class="selectionlist">
						<table>
						<tr>
						<td>
							<select name="parents" id="parents" 
								class="auto-init"
								data-auto-init="link-container"
								data-initial-items="[<%=HTML.encodeTags(jsonParents.toJSONString()) %>]"
								data-initial-action="<%=bioAssay == null ? 1 : 0 %>"
								size="4" multiple>
							</select>
						</td>
						<td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnAddParents"
									subclass="leftaligned"
									style="width: 12em;"
									title="Add&nbsp;bioassays&hellip;" 
									tooltip="Add parent derived bioassays"
								/>
								<base:button 
									subclass="leftaligned auto-init"
									data-auto-init="remove-link"
									data-list-id="parents"
									style="width: 12em;"
									title="Remove" 
									tooltip="Remove the selected derived bioassays"
								/>
							</base:buttongroup>
						</td>
						</tr>
						</table>
						</div>
						
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			<tr>
				<th>Extract</th>
				<td>
					<base:select 
						id="extract_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentExtract%>"
						denied="<%=!readCurrentExtract%>"
						newitem="<%=bioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=bioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Kit</th>
				<td>
					<base:select 
						id="kit_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentKit%>"
						denied="<%=!readCurrentKit%>"
						recent="<%=recentKits%>"
						newitem="<%=bioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Hardware</th>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						defaultitems="<%=defaultHardware%>"
						newitem="<%=bioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Software</th>
				<td>
					<base:select 
						id="software_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentSoftware%>"
						denied="<%=!readCurrentSoftware%>"
						recent="<%=recentSoftware%>"
						defaultitems="<%=defaultSoftware%>"
						newitem="<%=bioAssay == null%>"
					/>
				</td>
				<td></td>
			</tr>

			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(bioAssay == null ? cc.getPropertyValue("description") : bioAssay.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<jsp:include page="../../common/datafiles/select_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>		
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
			<%if (bioAssay == null) {%><br>
				<base:icon image="unchangeable.png" />= can't be changed later
			<%}%>
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
